import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class RandomWalk extends Frame
{  public double Pi = 3.14159265358979; public int numDsp;
   public double LeftP, TopP, sX, sY;
   public double currentX, currentY; // ݂̕`ʒu
   public RandomWalk()
   {  setSize(1100,700);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private boolean UnitRandom(Graphics g)
   {  int MX=5000;
      double [][]XY = new double[MX][2];
      double W = 4;double L = 8; double X = 0; double Y = W / 2; int K = 0;
      XY[K][0] = X; XY[K][1] = Y; K++;
      while(X < L)
      { double TH = 2 * Pi * Math.random();
        X += 0.5 * Math.cos(TH); Y += 0.5 * Math.sin(TH);
        if(K>=MX) return false;
        XY[K][0] = X; XY[K][1] = Y; K++;
        if(X < 0 || Y < 0 || Y > W) return false;
      }
      double X1=(double) (numDsp % 5)*200+50; double Y1=(double) (numDsp / 5)*200+100;
      numDsp++;
      drawInit(X1, Y1, 20, 20);
      g.setColor(new Color(0,0,255));
      g.drawRect(Xpos(0),Ypos(0),(int)(sX*L),(int)(sY*W));
      boolean Flag=false;
      g.setColor(new Color(255,0,0));
      for(int i=0; i < K; i++) Flag = Draw(g,XY[i][0],XY[i][1],Flag); 
      

      return true;
    } 
    private double RandomWalk(Graphics g)
    {  int N = 10000; int M = 0; numDsp=0;
       for(int i = 1; i <= N; i++)
       { boolean r = UnitRandom(g); if(r) M++;
       }
       return (double)M/(double)N;
    }
   public void drawInit(double X1, double Y1, double SX, double SY)
   {  LeftP = X1; TopP = Y1; sX = SX; sY = SY;
   }
   public int Xpos(double X)
   {  return (int)(LeftP + X * sX);}
   public int Ypos(double Y)
   {  return (int)(TopP  + Y * sY);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.fillOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawCircle(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawRect(Graphics g, double X, double Y)
   {  g.drawRect(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }
   
   public void paint(Graphics g)
   { setTitle("");
     double R =RandomWalk( g)*100;
     g.setColor(new Color(0,0,0));
     g.drawString(" m = " + round(R,4),50,50);
   }
   public static void main(String[] args)
   {  Frame w = new RandomWalk();
      w.setVisible(true);
   }
}
